Package ghidra.app.decompiler

# Class ClangStatement

java.lang.Object
ghidra.app.decompiler.ClangTokenGroup
ghidra.app.decompiler.ClangStatement

All Implemented Interfaces:
  `ClangNode`, `Iterable<ClangNode>`

public class ClangStatement extends ClangTokenGroup
A source code statement (as typically terminated by ';' in C) A statement must have a p-code operation associated with it. In the case of conditional flow control operations, there are usually two lines associated with the statement one containing the '{' and one containing '}'. The one containing the actual conditional branch is considered a C statement, while the other one is just considered a blank line. I.e. if (expression) { is a C statement, while the line containing the closing '}' by itself is considered blank

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ClangStatement(ClangNode par)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `decode(Decoder decoder, PcodeFactory pfactory)`
  Decode this text from an encoded stream.
  `PcodeOp`
  `getPcodeOp()`

  ### Methods inherited from class ghidra.app.decompiler.ClangTokenGroup

  `AddTokenGroup, Child, flatten, getClangFunction, getMaxAddress, getMinAddress, iterator, numChildren, Parent, setHighlight, stream, tokenIterator, toString`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface java.lang.Iterable

  `forEach, spliterator`

- ## Constructor Details

  - ### ClangStatement

    public ClangStatement(ClangNode par)

- ## Method Details

  - ### getPcodeOp

    public PcodeOp getPcodeOp()
    Returns:
      the (final) p-code operation associated with the statement.

  - ### decode

    public void decode(Decoder decoder, PcodeFactory pfactory) throws DecoderException
    Description copied from class: `ClangTokenGroup`
    Decode this text from an encoded stream.
    Overrides:
      `decode` in class `ClangTokenGroup`
    Parameters:
      `decoder` - is the decoder for the stream
      `pfactory` - is used to look up p-code attributes to associate with tokens
    Throws:
      `DecoderException` - for problems decoding the stream